<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Type Grammar</TITLE>
<link href="builder_10.html" rel=Next>
<link href="builder_8.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_8.html">previous</A>, <A HREF="builder_10.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC24" HREF="builder_toc.html#TOC24">Type Grammar</A></H2>

<P>
The following is a brief outline of the grammar used in parsing the type
strings. 

</P>
<DL COMPACT>

<DT>&#60;type name&#62;:
<DD>
<DL COMPACT>

<DT>
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;type extend&#62;:
<DD>
<DL COMPACT>

<DT><SAMP>`const'</SAMP>
<DD>
<DT><SAMP>`volatile'</SAMP>
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;type extend list&#62;:
<DD>
<DL COMPACT>

<DT>&#60;type extend&#62;
<DD>
<DT>&#60;type extend list&#62; &#60;type extend&#62;
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;type spec&#62;:
<DD>
<DL COMPACT>

<DT><SAMP>`void'</SAMP>
<DD>
<DT><SAMP>`char'</SAMP>
<DD>
<DT><SAMP>`short'</SAMP>
<DD>
<DT><SAMP>`int'</SAMP>
<DD>
<DT><SAMP>`int16'</SAMP>
<DD>
<DT><SAMP>`int32'</SAMP>
<DD>
<DT><SAMP>`int64'</SAMP>
<DD>
<DT><SAMP>`long'</SAMP>
<DD>
<DT><SAMP>`unsigned'</SAMP>
<DD>
<DT><SAMP>`unsigned16'</SAMP>
<DD>
<DT><SAMP>`unsigned32'</SAMP>
<DD>
<DT><SAMP>`unsigned64'</SAMP>
<DD>
<DT><SAMP>`float'</SAMP>
<DD>
<DT><SAMP>`float64'</SAMP>
<DD>
<DT><SAMP>`double'</SAMP>
<DD>
<DT>&#60;type spec&#62;
<DD>
<DT>&#60;struct/union spec&#62;
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;full type spec&#62;:
<DD>
<DL COMPACT>

<DT><SAMP>`%%'</SAMP>      next in the arg list
<DD>
<DT><SAMP>`%'</SAMP>&#60;number&#62;type with id &#60;number&#62;
<DD>
<DT>&#60;type spec&#62;
<DD>
<DT>&#60;type extend list&#62; &#60;type spec&#62;
<DD>
<DT>&#60;type spec&#62; &#60;array disc.&#62;
<DD>
<DT>&#60;type extend list&#62; &#60;type spec&#62; &#60;array disc.&#62;
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;named full type spec&#62;:
<DD>
<DL COMPACT>

<DT>&#60;type name&#62;
<DD>
<DT>&#60;type spec&#62;  &#60;type name&#62;
<DD>
<DT>&#60;type extend list&#62; &#60;type spec&#62; &#60;type name&#62;
<DD>
<DT>&#60;type spec&#62; &#60;type name&#62; &#60;array disc.&#62;
<DD>
<DT>&#60;type extend list&#62; &#60;type spec&#62; &#60;type name&#62; &#60;array disc.&#62;
<DD>
<DT>&#60;func call&#62;
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;func call&#62;:
<DD>
<DL COMPACT>

<DT>&#60;named full type spec&#62; <SAMP>`('</SAMP> <SAMP>`)'</SAMP>
<DD>
<DT>&#60;named full type spec&#62; <SAMP>`('</SAMP> &#60;expr list&#62; <SAMP>`)'</SAMP>
<DD>
</DL>
</DL>
<P>
     
<DL COMPACT>

<DT>&#60;struct/union spec&#62;:
<DD>
<DL COMPACT>

<DT>&#60;type name&#62;
<DD>
<DT>struct <SAMP>`{'</SAMP> &#60;decl. list&#62; <SAMP>`}'</SAMP>
<DD>
<DT>union <SAMP>`{'</SAMP> &#60;decl. list&#62; <SAMP>`}'</SAMP>
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;decl. list&#62;:
<DD>
<DL COMPACT>

<DT>&#60;named full type spec&#62;
<DD>
<DT>&#60;decl. list&#62;<SAMP>`;'</SAMP> &#60;named full type spec&#62;
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;array disc.&#62;:
<DD>
<DL COMPACT>

<DT><SAMP>`['</SAMP> &#60;number&#62; <SAMP>`]'</SAMP>
<DD>
<DT>&#60;array disc.&#62; <SAMP>`['</SAMP> &#60;number&#62; <SAMP>`]'</SAMP>
<DD>
</DL>
</DL>

<DL COMPACT>

<DT>&#60;expr list&#62;:
<DD>
<DL COMPACT>

<DT>&#60;full type spec&#62;
<DD>
<DT>&#60;named full type spec&#62;
<DD>
<DT>&#60;expr list&#62; <SAMP>`,'</SAMP> &#60;full type spec&#62;
<DD>
<DT>&#60;expr list&#62; <SAMP>`,'</SAMP> &#60;named full type spec&#62;
<DD>
</DL>
</DL>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_8.html">previous</A>, <A HREF="builder_10.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
